/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**#include <qmessagebox.h>
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
   
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <qvalidator.h>
#include "serial.h"
#include <qmessagebox.h>
#include <qtextbrowser.h>
#include <qtimer.h> 
#include <qdatetime.h>
#include <qfile.h>
#include <qdatetime.h> 
#include <qslider.h> 
#include <qscrollbar.h> 
#include <qcombobox.h>
#include <qlineedit.h> 

int teste = 0;
int teste2 =0;
int contador=3;
Serial porta;
QString line;
QChar ch;

void CtrlForm::init()
    {
      PortaConfig();
    }

void CtrlForm::send()
{

    
    unsigned char aux[3]; 
    //--VAI BUSCAR OS VALORES DA JUNTA, POS E SPEED 
    QString junta =  jointlineEdit->text();
    int pos = positionscrollBar->value();
    QString speed =SPEDD_comboBox ->currentText();
 
    //--CAT TODAS AS STRING ------------
    aux[0] = junta.toInt();
    aux[1] = pos;
    aux[2] = speed.toInt();
    
    //--ENVIA PELA PORTA----------
    porta.Write(aux, 3);
    read();
}


void CtrlForm::read()
{  
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   if (porta.IsOpen()) {
       QMessageBox::information( this,"Debug", "Porta aberta");
   }
    
   res = porta.Read(buff, 100);
   //char buf[100];
//   sprintf(buf, "%i", res);
   //QMessageBox::information( this,"Porta_leu", buf);
   
   
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			//QMessageBox::information( this,"Estado", "Estamos a receber");
			
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm:: PortaConfig()
{
     QString port = port_comboBox->currentText();
     porta.SetName(port);
      
     int baud_aux,baud;
     QString baudrate =baudrate_comboBox ->currentText();
     baud_aux = baudrate.toInt();
     switch(baud_aux)
              {
	     case   19200:
		 baud = 13;
		 break;
	     case   9600:
	               baud = 12;
		 break;
	}
		     
     porta.SetBaudRate(baud);

     porta.SetParity(0);

     porta.SetDataBits(DATA_8);

     porta.SetStopBits(1);

     porta.SetFlowControl(0);
     
     porta.SetTimeout(1);  
     //--VERIFICA SE APORTA ESTA ABERTA

      if (porta.Open() == FALSE)  
          {
	char str[100];
	porta.GetErrorMsg(str);
	QMessageBox::information( this, "Erro", str);
      };
}



void CtrlForm::position_timerDone()
{
    //limpa o buffer da porta
    clean_buffer();
    //----MANDAR ORDEM PARA ENVIO DE VALORES DAS POSIÇOES JUNTAS
    unsigned char send[3];
    send[1] =0;
    send[2] =0;
    
    int val[8] = {128,129,130,132,132,133,134,137};
    int cont;
    Rec_textBrowser->clear();
    //--ENVIA PELA PORTA----------
    
    int j, i;
    
    for (j=0;j<8;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	unsigned char buff[255],buff_temp[255];
	cont=0;
	int res = 1; 
//	while (res>0){
	         res = porta.Read(buff, 3);
//	         buff[cont] = buff_temp[0];
//		 printf("o valor do res e : %d\n",res);
//	         cont ++;
//                    }
//	printf("o valor do cont e : %d\n",cont);
	  
	  if (res > 0) {
		aux.sprintf("\n");
		aux = Rec_textBrowser->text() + aux;
		Rec_textBrowser->setText(aux);
		Rec_textBrowser->scrollToBottom();
		for (i=0; i<res; i++) {
		
		    if (i<res-1)
		              {
			aux.sprintf(" %d,", buff[i]);
		    }
		else
		    {
			 aux.sprintf(" %d", buff[i]);  
			}
		aux = Rec_textBrowser->text() + aux;
		Rec_textBrowser->setText(aux);
		Rec_textBrowser->scrollToBottom();
				
		}
	    }
		//Actualiza a monitorizaçao das posiçoes das juntas
		int anca, joelho, inc_pes, tornozelo;
		switch (j)
		{
		case 0:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider->setValue(inc_pes);
	               break;
		 case 1:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider->setValue(tornozelo);
	               break;
		 case 2:
		        joelho = buff[2]; 
	                      JOELHO_slider->setValue(joelho);
	               break;
		 case 3:
		        anca = buff[2]; 
	                      ANCA_slider->setValue(anca);
	               break;
		 case 4:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider_2->setValue(anca);
	               break;
		 case 5:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider_2->setValue(tornozelo);
	               break;
		 case 6:
		        joelho = buff[2]; 
	                      JOELHO_slider_2->setValue(joelho);
	               break;
		 case 7:
		        anca = buff[2]; 
	                      ANCA_slider_2->setValue(anca);
	               break;
	               }
	                 
	    }
      //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      QFile file( textEdit2->text ()  );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( Rec_textBrowser->text(), qstrlen( Rec_textBrowser->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer1();		
     }
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}

void CtrlForm::sensor_timerDone()
{
 //----MANDAR ORDEM PARA ENVIO DE VALORES DOS SENSORES
    
    //limpa o buffer da porta
    clean_buffer();
    //ESCOLHA DA PLACA A MONITORIZAR
    int val[4];//= {192,196,200,204,208,212,216,220};
 
    QString val_aux1 = endPES1_comboBox->currentText();
    QString val_aux2 = endPES2_comboBox->currentText();
    QString val_aux3 = endINC_comboBox->currentText();
    QString val_aux4 = endGIROS_comboBox->currentText();

    val[0] = val_aux1.toInt();
    val[1] = val_aux2.toInt();
    val[2] = val_aux3.toInt();
    val[3] = val_aux4.toInt();
    
    textBrowser3->clear();
  
    unsigned char send[3];
    send[1]=0;
    send[2]=0;
    //--ENVIA PELA PORTA----------

    unsigned char buff[255],buff_temp[255];
    
    int j,i;
   
    for (j=0;j<4;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	int cont=0;
	int res=1;
//	while (res>0){
	         res = porta.Read(buff, 4);
//	         buff[cont] = buff_temp[0];
//	         cont++;
  //                     }
                             
		if (res > 0)  {
			aux.sprintf("\n");
			aux = textBrowser3->text() + aux;
			textBrowser3->setText(aux);
			textBrowser3->scrollToBottom();
			for (i=0; i<res; i++) {
			              if (i<res-1)
			              {
				aux.sprintf(" %d,", buff[i]);
			              }
				else
				{
				 aux.sprintf(" %d", buff[i]);  
				}      
				aux = textBrowser3->text() + aux;
				textBrowser3->setText(aux);
				textBrowser3->scrollToBottom();
				
			}
		}
	      //--VISUALIZAÇAO SENSOR PES , INCLINOMETROS, GIROSCOPIO
		
		//PE DIREITO
		if (j==0)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider->setValue(pe1);
		    pe2_slider->setValue(pe2);	
		    pe3_slider->setValue(pe3);	
		    pe4_slider->setValue(pe4);	
		}
		//PE ESQUERDO
		if (j==1)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider_2->setValue(pe1);
		    pe2_slider_2->setValue(pe2);	
		    pe3_slider_2->setValue(pe3);	
		    pe4_slider_2->setValue(pe4);	
		}
		//INCLINOMETRO
		if(j==2)
		{
		    int inclin1,inclin2;
		    inclin1 = buff[0];
		    inclin1_slider->setValue(inclin1);
		    inclin2 = buff[1];
		    inclin2_slider->setValue(inclin2);
		 }
                               //GIROSCOPIO
    		if (j==3)
                                {
		    int giro;
		    giro = buff[0];
		    giro_slider->setValue(giro);
		 }
    
	    }
   
    
       //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      //QString name =c->currentText();
      QFile file( textEdit3->text () );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( textBrowser3->text(), qstrlen( textBrowser3->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer2();		
     } 
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}	

void CtrlForm::active_timer1()
{
        //--ACTIVAR UM TIMER1---------------------------------------  
        teste = 0;
        QTimer *timer1 = new QTimer( this);
        connect( timer1, SIGNAL(timeout()),SLOT(position_timerDone()) );
        timer1->start( 100, TRUE ); 
}

void CtrlForm::active_timer2()
{
        //--ACTIVAR UM TIMER2---------------------------------------  
        teste = 0;
        QTimer *timer2 = new QTimer( this);
        connect( timer2, SIGNAL(timeout()),SLOT(sensor_timerDone()) );
        timer2->start( 100, TRUE ); 
}

void CtrlForm::active_timer3()
{
        //--ACTIVAR UM TIMER2---------------------------------------  
        teste = 0;
        QTimer *timer3 = new QTimer( this);
        connect( timer3, SIGNAL(timeout()),SLOT(gravar_pos()) );
        timer3->start( 100, TRUE ); 
}
void CtrlForm::quit_timer()
{
  teste = 1;
}


void CtrlForm::clean_buffer()
{
    //LIMPA A PORTA
    int res;
   unsigned char buff[255];
   while (res>0){
       res = porta.Read(buff, 1);
   }
}

void CtrlForm::can_teste()
{
    //TESTE AO CAN
    unsigned char send[3]={0,255,255};
    
   porta.Write(send, 3);
   
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   res = porta.Read(buff, 8);
 
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm::clean_juntas()
{
    //COLOCA A ZERO TODAS AS VARIAVEIS DE VISUALIZAÇAO DAS JUNTAS
ANCA_slider->setValue(0);
JOELHO_slider->setValue(0);
TORNOZELO_slider->setValue(0);
PE_INCLI_slider->setValue(0);
ANCA_slider_2->setValue(0);
JOELHO_slider_2->setValue(0);
TORNOZELO_slider_2->setValue(0);
PE_INCLI_slider_2->setValue(0);
Rec_textBrowser->clear();
}


void CtrlForm::clean_sensores()
{
    //COLOCA A ZERO TODAS AS VARIAVEIS DE VISUALIZAÇAO DO SENSORES
pe1_slider->setValue(0);
pe2_slider->setValue(0);
pe3_slider->setValue(0);
pe4_slider->setValue(0);
pe1_slider_2->setValue(0);
pe2_slider_2->setValue(0);
pe3_slider_2->setValue(0);
pe4_slider_2->setValue(0);
inclin1_slider->setValue(0);
inclin2_slider->setValue(0);
giro_slider->setValue(0);
textBrowser3->clear();
}


void CtrlForm::Mov_juntas()
{
    
   clean_buffer();
  unsigned char send_juntas[12];
  unsigned char vel_juntas;
  //PERNA DIREITA
  QString aux1 = FancaD_textEdit->text();
  send_juntas[0] = aux1.toInt();
  QString aux2 = LancaD_textEdit->text();
  send_juntas[1] = aux2.toInt();
  QString aux3 = VancaD_textEdit->text();
  send_juntas[2] = aux3.toInt();
  QString aux4 = joelhoD_textEdit->text();
  send_juntas[3] = aux4.toInt();
  QString aux5 = IpeD_textEdit->text();
  send_juntas[4] = aux5.toInt();
  QString aux6 = tornozeloD_textEdit->text();
  send_juntas[5] = aux6.toInt();
  
  //PERNA ESQUERDA
  QString aux1_1 = FancaE_textEdit->text();
  send_juntas[6] = aux1_1.toInt();
  QString aux2_2 = LancaE_textEdit->text();
  send_juntas[7] = aux2_2.toInt();
  QString aux3_3 = VancaE_textEdit->text();
  send_juntas[8] = aux3_3.toInt();
  QString aux4_4 = joelhoE_textEdit->text();
  send_juntas[9] = aux4_4.toInt();
  QString aux5_5 = IpeE_textEdit->text();
  send_juntas[10] = aux5_5.toInt();
  QString aux6_6 = tornozeloE_textEdit->text();
  send_juntas[11] = aux6_6.toInt();
  
  
    QString aux_vel = vel_comboBox->currentText();
  vel_juntas = aux_vel.toInt();
 // unsigned char val[36] = {74,send_juntas[0],0,73,send_juntas[1],0,72,send_juntas[2],0,66,send_juntas[3],0,64,send_juntas[4],0,65,send_juntas[5],0,78,send_juntas[6],0,77,send_juntas[7],0,76,send_juntas[8],0,70,send_juntas[9],0,68,send_juntas[10],0,69,send_juntas[11],0};
 
    unsigned char val[36] = {74,send_juntas[0],vel_juntas,73,send_juntas[1],vel_juntas,72,send_juntas[2],vel_juntas,66,send_juntas[3],vel_juntas,64,send_juntas[4],vel_juntas,65,send_juntas[5],vel_juntas,78,send_juntas[6],vel_juntas,77,send_juntas[7],vel_juntas,76,send_juntas[8],vel_juntas,70,send_juntas[9],vel_juntas,68,send_juntas[10],vel_juntas,69,send_juntas[11],vel_juntas};  
 porta.Write(val, 36);
  
 porta.Write(val, 36);  
unsigned char receb[255];
int res;
res = porta.Read(receb,36);
//
//int i;
//for (i=0; i<36; i++) 
//     {
     printf("res= %d\n",res);    
//     }
     teste2=0;
     gravar_pos();
}

void CtrlForm::file_mov()
{
    //ESCOLHA DO FICHEIRO PARA ENVIO DE ORDENS AO ROBOT
 QString name_file = file_mov_comboBox->currentText();   
 QStringList lines;   
 QFile file( name_file );
    if ( file.open( IO_ReadOnly ) ) {
        QTextStream stream( &file );

QString temp;	
        int i = 1,j;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); // line of text excluding '\n'
	    switch(i)
	    {
	    case 1:
		pe_direito();
		break;
	    case 2:
		pe_esquerdo();
		break;
		}
	    //printf( "%s\n", ch );
            //printf( "%3d: %s\n", i++, line.latin1() );
            i++;
            lines += line;
        }
        file.close();
    }
}

void CtrlForm::pe_direito()
{
    
    //PE DIREITO - LEITURA DO FICHEIRO E COLOCA VALORES NAS POSIÇOES CERTAS PARA O ENVIO
    int j,t;
    char	virg=',';
QString temp1;
                    contador=3;  
                    t=1;
		    
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		    // printf( "t=0" );
		 }
		 else
		 {
		     temp1 =temp1 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
		 
	     }	    
	     FancaD_textEdit-> setText(temp1);
	     t=1;
	     contador=contador + 1;
QString temp2;

	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp2 =temp2 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }
	     }
	     LancaD_textEdit-> setText(temp2); 
	     
	     t=1;
	     contador=contador + 1;
QString temp3;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp3 =temp3 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
	     }
	     VancaD_textEdit-> setText(temp3);
	     
	     t=1;
	     contador=contador + 1;
QString temp4;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		    // printf( "t=0" );
		 }
		 else
		 {
		     temp4 =temp4 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
	     }
	      joelhoD_textEdit-> setText(temp4);    
	      
	     t=1;
	     contador=contador + 1;
QString temp5;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp5 =temp5 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }
	     }
	      IpeD_textEdit-> setText(temp5);  	   
	      
	     t=1;
	     contador=contador + 1;
QString temp6;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp6 =temp6 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }	    
	       tornozeloD_textEdit-> setText(temp6); 	      
	 }
}
void CtrlForm::pe_esquerdo()
{
    
    //PE ESQUERDO - LEITURA DO FICHEIRO E COLOCA VALORES NAS POSIÇOES CERTAS PARA O ENVIO
    int j,t;
    char	virg=',';
QString temp1;
                    t=1;
	      contador=3;   
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		    // printf( "t=0" );
		 }
		 else
		 {
		     temp1 =temp1 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
		 
	     }	    
	     FancaE_textEdit-> setText(temp1);
	     t=1;
	     contador=contador + 1;
QString temp2;

	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp2 =temp2 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }
	     }
	     LancaE_textEdit-> setText(temp2); 
	     
	     t=1;
	     contador=contador + 1;
QString temp3;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp3 =temp3 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
	     }
	     VancaE_textEdit-> setText(temp3);
	     
	     t=1;
	     contador=contador + 1;
QString temp4;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		    // printf( "t=0" );
		 }
		 else
		 {
		     temp4 =temp4 + ch; 
		     contador++;
		   //  printf( "estou bem" );
		 }
	     }
	      joelhoE_textEdit-> setText(temp4);    
	      
	     t=1;
	     contador=contador + 1;
QString temp5;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp5 =temp5 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }
	     }
	      IpeE_textEdit-> setText(temp5);  	   
	      
	     t=1;
	     contador=contador + 1;
QString temp6;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		     //printf( "t=0" );
		 }
		 else
		 {
		     temp6 =temp6 + ch; 
		     contador++;
		     //printf( "estou bem" );
		 }	    
	       tornozeloE_textEdit-> setText(temp6); 	      
	}
	     
}
void CtrlForm::gravar_pos()
{
if(teste2==0)   
    {
    clean_buffer();
    //ENVIA BYTES PARA A RECEBER OS VAOLRES DAS JUNTAS E SENSORES DE CADA PERNA
unsigned char val_pe_D[21] = {138,0,0,137,0,0,136,0,0,130,0,0,128,0,0,129,0,0,192,0,0};
unsigned char val_pe_E[21] = {142,0,0,141,0,0,140,0,0,134,0,0,132,0,0,133,0,0,196,0,0};
unsigned char res_pe_D[22], res_pe_E[22];
int res , cont = 2 , i , j ,res1; 
QString temp,temp1;


porta.Write(val_pe_D, 21);
res = porta.Read(res_pe_D, 22);
porta.Write(val_pe_E, 21);
res1 = porta.Read(res_pe_E, 22);
printf("res=%d\n",res);	
                             gravar_textBrowser->clear();
//Pe direito
		if (res == 22)  {
			temp1.sprintf("\n");
			temp1 = gravar_textBrowser->text() + temp1;
			gravar_textBrowser->setText(temp1);
			gravar_textBrowser->scrollToBottom();
			gravar_textBrowser->setText("PD,");
			cont=2;
			while (cont<18) {
			    if ((cont>1)&(cont<17)){
				temp1.sprintf(" %d,", res_pe_D[cont]);
			    }
			    else
			    {
				temp1.sprintf(" %d,", res_pe_D[cont]);
			    }
				temp1 = gravar_textBrowser->text() + temp1;
				gravar_textBrowser->setText(temp1);
				gravar_textBrowser->scrollToBottom();
				cont= cont+3;
			}
			for (i=18;i<22;i++){
			    if ((i>17)&(i<21)){
				temp1.sprintf(" %d,", res_pe_D[i]);
			    }
			    else
			    {
				temp1.sprintf(" %d", res_pe_D[i]);
			    }
			   temp1 = gravar_textBrowser->text() + temp1;
			   gravar_textBrowser->setText(temp1);
			   gravar_textBrowser->scrollToBottom();
			}
		}
			     
//Pe esquerdo
porta.Write(val_pe_E, 21);
res = porta.Read(res_pe_E, 22);
printf("res=%d\n",res);	
                             	gravar_textBrowser_2->clear();	
		if (res == 22)  {
			temp1.sprintf("\n");
			temp1 = gravar_textBrowser_2->text() + temp1;
			gravar_textBrowser_2->setText(temp1);
			gravar_textBrowser_2->scrollToBottom();
			gravar_textBrowser_2->setText("PE,");
			cont=2;
			while (cont<18) {
			    if ((cont>1)&(cont<17)){
				temp1.sprintf(" %d,", res_pe_E[cont]);
			    }
			    else
			    {
				temp1.sprintf(" %d,", res_pe_E[cont]);
			    }
				temp1 = gravar_textBrowser_2->text() + temp1;
				gravar_textBrowser_2->setText(temp1);
				gravar_textBrowser_2->scrollToBottom();
				cont= cont+3;
			}
			for (i=18;i<22;i++){
			    if ((i>17)&(i<21)){
				temp1.sprintf(" %d,", res_pe_E[i]);
			    }
			    else
			    {
				temp1.sprintf(" %d", res_pe_E[i]);
			    }
			   temp1 = gravar_textBrowser_2->text() + temp1;
			   gravar_textBrowser_2->setText(temp1);
			   gravar_textBrowser_2->scrollToBottom();
			}
		}		
  
//ESCREVER NAS CAIXAS DE TEXTO
gravar_total_textBrowser->setText(gravar_textBrowser->text());
temp = gravar_total_textBrowser->text();
temp.sprintf("\n");
temp = gravar_total_textBrowser->text() + temp;

temp = temp + gravar_textBrowser_2->text();
gravar_total_textBrowser->setText(temp);
textBrowser2->scrollToBottom();

 //ESCREVER NO FICHEIRO
      QFile file( mov_juntas_grav_textEdit->text() );
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( gravar_total_textBrowser->text(), qstrlen( gravar_total_textBrowser->text() ) );
      temp.sprintf("\n");
      file.writeBlock( temp, qstrlen( temp) );
      file.close();
      active_timer3();
  }
}

void CtrlForm::parar_gravar()
{
    teste2=1;
}
void CtrlForm::Mov_juntas_sem_gravar()
{
   clean_buffer();
  unsigned char send_juntas[12];
  unsigned char vel_juntas;
  //PERNA DIREITA
  QString aux1 = FancaD_textEdit->text();
  send_juntas[0] = aux1.toInt();
  QString aux2 = LancaD_textEdit->text();
  send_juntas[1] = aux2.toInt();
  QString aux3 = VancaD_textEdit->text();
  send_juntas[2] = aux3.toInt();
  QString aux4 = joelhoD_textEdit->text();
  send_juntas[3] = aux4.toInt();
  QString aux5 = IpeD_textEdit->text();
  send_juntas[4] = aux5.toInt();
  QString aux6 = tornozeloD_textEdit->text();
  send_juntas[5] = aux6.toInt();
  
  //PERNA ESQUERDA
  QString aux1_1 = FancaE_textEdit->text();
  send_juntas[6] = aux1_1.toInt();
  QString aux2_2 = LancaE_textEdit->text();
  send_juntas[7] = aux2_2.toInt();
  QString aux3_3 = VancaE_textEdit->text();
  send_juntas[8] = aux3_3.toInt();
  QString aux4_4 = joelhoE_textEdit->text();
  send_juntas[9] = aux4_4.toInt();
  QString aux5_5 = IpeE_textEdit->text();
  send_juntas[10] = aux5_5.toInt();
  QString aux6_6 = tornozeloE_textEdit->text();
  send_juntas[11] = aux6_6.toInt();
  
  QString aux_vel = vel_comboBox->currentText();
  vel_juntas = aux_vel.toInt();
  
//  unsigned char val[36] = {74,send_juntas[0],0,73,send_juntas[1],0,72,send_juntas[2],0,66,send_juntas[3],0,64,send_juntas[4],0,65,send_juntas[5],0,78,send_juntas[6],0,77,send_juntas[7],0,76,send_juntas[8],0,70,send_juntas[9],0,68,send_juntas[10],0,69,send_juntas[11],0};
  unsigned char val_D[18] = {74,send_juntas[0],vel_juntas,73,send_juntas[1],vel_juntas,72,send_juntas[2],vel_juntas,66,send_juntas[3],vel_juntas,64,send_juntas[4],vel_juntas,65,send_juntas[5],vel_juntas};
  unsigned char val_E[18]  = {78,send_juntas[6],vel_juntas,77,send_juntas[7],vel_juntas,76,send_juntas[8],vel_juntas,70,send_juntas[9],vel_juntas,68,send_juntas[10],vel_juntas,69,send_juntas[11],vel_juntas};  
  
unsigned char receb[255];
int res;

porta.Write(val_D, 18);  
//res = porta.Read(receb,18);
porta.Write(val_E, 18);

int cont=1;
while (res>0){
res = porta.Read(receb,1);

	         cont++;
	     }
printf("res= %d\n",res);    


//	while (res>0){
	        // res = porta.Read(buff, 4);
//	         buff[cont] = buff_temp[0];
//	         cont++;
  //                     }
}
