/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**#include <qmessagebox.h>
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
   
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <qvalidator.h>
#include "serial.h"
#include <qmessagebox.h>
#include <qtextbrowser.h>
#include <qtimer.h> 
#include <qdatetime.h>
#include <qfile.h>
#include <qdatetime.h> 
#include <qslider.h> 
#include <qscrollbar.h> 
#include <qcombobox.h>
#include <qlineedit.h> 
#include <sys/time.h>
//definiçoes
//#define NUM_TOTAL_JOINT_PERNA 	6

#define S_ANCA_FRENTE_D 138
#define S_ANCA_LADO_D 	137
#define S_ANCA_VIRAR_D 	136
#define S_PE_JOELHO_D 	130
#define S_PE_LADO_D 	128
#define S_PE_FRENTE_D 	129
#define S_ANCA_FRENTE_E 142
#define S_ANCA_LADO_E 	141
#define S_ANCA_VIRAR_E 	140
#define S_PE_JOELHO_E 	134
#define S_PE_LADO_E 	132
#define S_PE_FRENTE_E 	133

#define SENSOR_PE_D     	192
#define SENSOR_PE_E     	196

#define ANCA_FRENTE_D 	74
#define ANCA_LADO_D 	73
#define ANCA_VIRAR_D 	72
#define PE_JOELHO_D 	66 
#define PE_LADO_D 	64  
#define PE_FRENTE_D 	65 
#define ANCA_FRENTE_E 	78   
#define ANCA_LADO_E  	77 
#define ANCA_VIRAR_E  	76
#define PE_JOELHO_E  	70
#define PE_LADO_E  	68
#define PE_FRENTE_E 	69


 unsigned char val_juntas_D[7][3] ={
     {S_ANCA_FRENTE_D,0,0},	
     {S_ANCA_LADO_D,0,0},
     {S_ANCA_VIRAR_D,0,0},
     {S_PE_JOELHO_D,0,0},
     {S_PE_LADO_D,0,0},
     {S_PE_FRENTE_D,0,0},
     {SENSOR_PE_D,0,0}};
 unsigned char val_juntas_E[7][3] ={
    {S_ANCA_FRENTE_E,0,0},	
    {S_ANCA_LADO_E,0,0},
    {S_ANCA_VIRAR_E,0,0},
    {S_PE_JOELHO_E,0,0},
    {S_PE_LADO_E,0,0},
    {S_PE_FRENTE_E,0,0},
    {SENSOR_PE_E,0,0}};
 
 unsigned char juntas_D[6][3] ={
     {ANCA_FRENTE_D,0,0},	
     {ANCA_LADO_D,0,0},
     {ANCA_VIRAR_D,0,0},
     {PE_JOELHO_D,0,0},
     {PE_LADO_D,0,0},
     {PE_FRENTE_D,0,0}};
 
 unsigned char juntas_E[6][3] ={
     {ANCA_FRENTE_E,0,0},	
     {ANCA_LADO_E,0,0},
     {ANCA_VIRAR_E,0,0},
     {PE_JOELHO_E,0,0},
     {PE_LADO_E,0,0},
     {PE_FRENTE_E,0,0}};

 unsigned char sensor_pes[2][3] = {
     {SENSOR_PE_D,0,0},
     {SENSOR_PE_E,0,0}};
 
 
int teste = 0;
int teste2 =0;
int contador=3;
Serial porta;
QString line;
QChar ch;

void CtrlForm::init()
    {
      PortaConfig();
    }

void CtrlForm::send()
{

    
    unsigned char aux[3]; 
    //--VAI BUSCAR OS VALORES DA JUNTA, POS E SPEED 
    QString junta =  jointlineEdit->text();
    int pos = positionscrollBar->value();
    QString speed =SPEDD_comboBox ->currentText();
 
    //--CAT TODAS AS STRING ------------
    aux[0] = junta.toInt();
    aux[1] = pos;
    aux[2] = speed.toInt();
    
    //--ENVIA PELA PORTA----------
    porta.Write(aux, 3);
    read();
}


void CtrlForm::read()
{  
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   if (porta.IsOpen()) {
       QMessageBox::information( this,"Debug", "Porta aberta");
   }
    
   res = porta.Read(buff, 100);
   //char buf[100];
//   sprintf(buf, "%i", res);
   //QMessageBox::information( this,"Porta_leu", buf);
   
   
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			//QMessageBox::information( this,"Estado", "Estamos a receber");
			
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm:: PortaConfig()
{
     QString port = port_comboBox->currentText();
     porta.SetName(port);
      
     int baud_aux,baud;
     QString baudrate =baudrate_comboBox ->currentText();
     baud_aux = baudrate.toInt();
     switch(baud_aux)
              {
	     case   19200:
		 baud = 13;
		 break;
	     case   9600:
	               baud = 12;
		 break;
	}
		     
     porta.SetBaudRate(baud);

     porta.SetParity(0);

     porta.SetDataBits(DATA_8);

     porta.SetStopBits(1);

     porta.SetFlowControl(0);
     
     porta.SetTimeout(1);  
     //--VERIFICA SE APORTA ESTA ABERTA

      if (porta.Open() == FALSE)  
          {
	char str[100];
	porta.GetErrorMsg(str);
	QMessageBox::information( this, "Erro", str);
      };
}



void CtrlForm::position_timerDone()
{
    //limpa o buffer da porta
    clean_buffer();
    //----MANDAR ORDEM PARA ENVIO DE VALORES DAS POSIÇOES JUNTAS
    unsigned char send[3];
    send[1] =0;
    send[2] =0;
    
    int val[8] = {128,129,130,132,132,133,134,137};
    int cont;
    Rec_textBrowser->clear();
    //--ENVIA PELA PORTA----------
    
    int j, i;
    
    for (j=0;j<8;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	unsigned char buff[255],buff_temp[255];
	cont=0;
	int res = 1; 
//	while (res>0){
	         res = porta.Read(buff, 3);
//	         buff[cont] = buff_temp[0];
//		 printf("o valor do res e : %d\n",res);
//	         cont ++;
//                    }
//	printf("o valor do cont e : %d\n",cont);
	  
	  if (res > 0) {
		aux.sprintf("\n");
		aux = Rec_textBrowser->text() + aux;
		Rec_textBrowser->setText(aux);
		Rec_textBrowser->scrollToBottom();
		for (i=0; i<res; i++) {
		
		    if (i<res-1)
		              {
			aux.sprintf(" %d,", buff[i]);
		    }
		else
		    {
			 aux.sprintf(" %d", buff[i]);  
			}
		aux = Rec_textBrowser->text() + aux;
		Rec_textBrowser->setText(aux);
		Rec_textBrowser->scrollToBottom();
				
		}
	    }
		//Actualiza a monitorizaçao das posiçoes das juntas
		int anca, joelho, inc_pes, tornozelo;
		switch (j)
		{
		case 0:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider->setValue(inc_pes);
	               break;
		 case 1:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider->setValue(tornozelo);
	               break;
		 case 2:
		        joelho = buff[2]; 
	                      JOELHO_slider->setValue(joelho);
	               break;
		 case 3:
		        anca = buff[2]; 
	                      ANCA_slider->setValue(anca);
	               break;
		 case 4:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider_2->setValue(anca);
	               break;
		 case 5:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider_2->setValue(tornozelo);
	               break;
		 case 6:
		        joelho = buff[2]; 
	                      JOELHO_slider_2->setValue(joelho);
	               break;
		 case 7:
		        anca = buff[2]; 
	                      ANCA_slider_2->setValue(anca);
	               break;
	               }
	                 
	    }
      //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      QFile file( textEdit2->text ()  );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( Rec_textBrowser->text(), qstrlen( Rec_textBrowser->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer1();		
     }
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}

void CtrlForm::sensor_timerDone()
{
 //----MANDAR ORDEM PARA ENVIO DE VALORES DOS SENSORES
    
    //limpa o buffer da porta
    clean_buffer();
    //ESCOLHA DA PLACA A MONITORIZAR
    int val[4];//= {192,196,200,204,208,212,216,220};
 
    QString val_aux1 = endPES1_comboBox->currentText();
    QString val_aux2 = endPES2_comboBox->currentText();
    QString val_aux3 = endINC_comboBox->currentText();
    QString val_aux4 = endGIROS_comboBox->currentText();

    val[0] = val_aux1.toInt();
    val[1] = val_aux2.toInt();
    val[2] = val_aux3.toInt();
    val[3] = val_aux4.toInt();
    
    textBrowser3->clear();
  
    unsigned char send[3];
    send[1]=0;
    send[2]=0;
    //--ENVIA PELA PORTA----------

    unsigned char buff[255],buff_temp[255];
    
    int j,i;
   
    for (j=0;j<4;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	int cont=0;
	int res=1;
//	while (res>0){
	         res = porta.Read(buff, 4);
//	         buff[cont] = buff_temp[0];
//	         cont++;
  //                     }
                             
		if (res > 0)  {
			aux.sprintf("\n");
			aux = textBrowser3->text() + aux;
			textBrowser3->setText(aux);
			textBrowser3->scrollToBottom();
			for (i=0; i<res; i++) {
			              if (i<res-1)
			              {
				aux.sprintf(" %d,", buff[i]);
			              }
				else
				{
				 aux.sprintf(" %d", buff[i]);  
				}      
				aux = textBrowser3->text() + aux;
				textBrowser3->setText(aux);
				textBrowser3->scrollToBottom();
				
			}
		}
	      //--VISUALIZAÇAO SENSOR PES , INCLINOMETROS, GIROSCOPIO
		
		//PE DIREITO
		if (j==0)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider->setValue(pe1);
		    pe2_slider->setValue(pe2);	
		    pe3_slider->setValue(pe3);	
		    pe4_slider->setValue(pe4);	
		}
		//PE ESQUERDO
		if (j==1)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider_2->setValue(pe1);
		    pe2_slider_2->setValue(pe2);	
		    pe3_slider_2->setValue(pe3);	
		    pe4_slider_2->setValue(pe4);	
		}
		//INCLINOMETRO
		if(j==2)
		{
		    int inclin1,inclin2;
		    inclin1 = buff[0];
		    inclin1_slider->setValue(inclin1);
		    inclin2 = buff[1];
		    inclin2_slider->setValue(inclin2);
		 }
                               //GIROSCOPIO
    		if (j==3)
                                {
		    int giro;
		    giro = buff[0];
		    giro_slider->setValue(giro);
		 }
    
	    }
   
    
       //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      //QString name =c->currentText();
      QFile file( textEdit3->text () );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( textBrowser3->text(), qstrlen( textBrowser3->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer2();		
     } 
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}	

void CtrlForm::active_timer1()
{
        //--ACTIVAR UM TIMER1---------------------------------------  
        teste = 0;
        QTimer *timer1 = new QTimer( this);
        connect( timer1, SIGNAL(timeout()),SLOT(position_timerDone()) );
        timer1->start( 100, TRUE ); 
}

void CtrlForm::active_timer2()
{
        //--ACTIVAR UM TIMER2---------------------------------------  
        teste = 0;
        QTimer *timer2 = new QTimer( this);
        connect( timer2, SIGNAL(timeout()),SLOT(sensor_timerDone()) );
        timer2->start( 100, TRUE ); 
}

void CtrlForm::active_timer3()
{
        //--ACTIVAR UM TIMER2---------------------------------------  
        teste = 0;
        QTimer *timer3 = new QTimer( this);
        connect( timer3, SIGNAL(timeout()),SLOT(gravar_pos()) );
        timer3->start( 25,TRUE ); 
}
void CtrlForm::quit_timer()
{
  teste = 1;
}


void CtrlForm::clean_buffer()
{
    //LIMPA A PORTA
    int res;
   unsigned char buff[255];
   res = porta.Read(buff, 15);
}

void CtrlForm::can_teste()
{
    //TESTE AO CAN
    unsigned char send[3]={0,255,255};
    
   porta.Write(send, 3);
   
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   res = porta.Read(buff, 8);
 
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm::clean_juntas()
{
    //COLOCA A ZERO TODAS AS VARIAVEIS DE VISUALIZAÇAO DAS JUNTAS
ANCA_slider->setValue(0);
JOELHO_slider->setValue(0);
TORNOZELO_slider->setValue(0);
PE_INCLI_slider->setValue(0);
ANCA_slider_2->setValue(0);
JOELHO_slider_2->setValue(0);
TORNOZELO_slider_2->setValue(0);
PE_INCLI_slider_2->setValue(0);
Rec_textBrowser->clear();
}


void CtrlForm::clean_sensores()
{
    //COLOCA A ZERO TODAS AS VARIAVEIS DE VISUALIZAÇAO DO SENSORES
pe1_slider->setValue(0);
pe2_slider->setValue(0);
pe3_slider->setValue(0);
pe4_slider->setValue(0);
pe1_slider_2->setValue(0);
pe2_slider_2->setValue(0);
pe3_slider_2->setValue(0);
pe4_slider_2->setValue(0);
inclin1_slider->setValue(0);
inclin2_slider->setValue(0);
giro_slider->setValue(0);
textBrowser3->clear();
}


void CtrlForm::Mov_juntas()
{
    
   clean_buffer();
  unsigned char send_juntas[12];
  unsigned char vel_juntas;
  //PERNA DIREITA
  QString aux1 = FancaD_textEdit->text();
  send_juntas[0] = aux1.toInt();
  QString aux2 = LancaD_textEdit->text();
  send_juntas[1] = aux2.toInt();
  QString aux3 = VancaD_textEdit->text();
  send_juntas[2] = aux3.toInt();
  QString aux4 = joelhoD_textEdit->text();
  send_juntas[3] = aux4.toInt();
  QString aux5 = IpeD_textEdit->text();
  send_juntas[4] = aux5.toInt();
  QString aux6 = tornozeloD_textEdit->text();
  send_juntas[5] = aux6.toInt();
  
  //PERNA ESQUERDA
  QString aux1_1 = FancaE_textEdit->text();
  send_juntas[6] = aux1_1.toInt();
  QString aux2_2 = LancaE_textEdit->text();
  send_juntas[7] = aux2_2.toInt();
  QString aux3_3 = VancaE_textEdit->text();
  send_juntas[8] = aux3_3.toInt();
  QString aux4_4 = joelhoE_textEdit->text();
  send_juntas[9] = aux4_4.toInt();
  QString aux5_5 = IpeE_textEdit->text();
  send_juntas[10] = aux5_5.toInt();
  QString aux6_6 = tornozeloE_textEdit->text();
  send_juntas[11] = aux6_6.toInt();
  
  
    QString aux_vel = vel_comboBox->currentText();
  vel_juntas = aux_vel.toInt();
 // unsigned char val[36] = {74,send_juntas[0],0,73,send_juntas[1],0,72,send_juntas[2],0,66,send_juntas[3],0,64,send_juntas[4],0,65,send_juntas[5],0,78,send_juntas[6],0,77,send_juntas[7],0,76,send_juntas[8],0,70,send_juntas[9],0,68,send_juntas[10],0,69,send_juntas[11],0};
 
    unsigned char val[36] = {74,send_juntas[0],vel_juntas,73,send_juntas[1],vel_juntas,72,send_juntas[2],vel_juntas,66,send_juntas[3],vel_juntas,64,send_juntas[4],vel_juntas,65,send_juntas[5],vel_juntas,78,send_juntas[6],vel_juntas,77,send_juntas[7],vel_juntas,76,send_juntas[8],vel_juntas,70,send_juntas[9],vel_juntas,68,send_juntas[10],vel_juntas,69,send_juntas[11],vel_juntas};  
 porta.Write(val, 36);
  
 porta.Write(val, 36);  
unsigned char receb[255];
//int res;
//res = porta.Read(receb,36);
//
//int i;
//for (i=0; i<36; i++) 
//     {
 //    printf("res= %d\n",res);    
//     }
     teste2=0;
     gravar_pos();
}

void CtrlForm::file_mov()
{
    //ESCOLHA DO FICHEIRO PARA ENVIO DE ORDENS AO ROBOT
 QString name_file = file_mov_comboBox->currentText();   
 QStringList lines;   
 QFile file( name_file );
    if ( file.open( IO_ReadOnly ) ) {
        QTextStream stream( &file );

QString temp;	
        int i = 1,j;
        while ( !stream.atEnd() ) {
            line = stream.readLine(); 
	    switch(i)
	    {
	    case 1:
		pe_direito();
		break;
	    case 2:
		pe_esquerdo();
		break;
		}
            i++;
            lines += line;
        }
        file.close();
    }
}

void CtrlForm::pe_direito()
{
    
    //PE DIREITO - LEITURA DO FICHEIRO E COLOCA VALORES NAS POSIÇOES CERTAS PARA O ENVIO
    int j,t;
    char	virg=',';
QString temp1;
                    contador=3;  
                    t=1;
		    
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp1 =temp1 + ch; 
		     contador++;
		 }
		 
	     }	    
	     FancaD_textEdit-> setText(temp1);
	     t=1;
	     contador=contador + 1;
QString temp2;

	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp2 =temp2 + ch; 
		     contador++;
		 }
	     }
	     LancaD_textEdit-> setText(temp2); 
	     
	     t=1;
	     contador=contador + 1;
QString temp3;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp3 =temp3 + ch; 
		     contador++;
		 }
	     }
	     VancaD_textEdit-> setText(temp3);
	     
	     t=1;
	     contador=contador + 1;
QString temp4;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp4 =temp4 + ch; 
		     contador++;
		 }
	     }
	      joelhoD_textEdit-> setText(temp4);    
	      
	     t=1;
	     contador=contador + 1;
QString temp5;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp5 =temp5 + ch; 
		     contador++;
		 }
	     }
	      IpeD_textEdit-> setText(temp5);  	   
	      
	     t=1;
	     contador=contador + 1;
QString temp6;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp6 =temp6 + ch; 
		     contador++;
		 }	    
	       tornozeloD_textEdit-> setText(temp6); 	      
	 }
}
void CtrlForm::pe_esquerdo()
{
    
    //PE ESQUERDO - LEITURA DO FICHEIRO E COLOCA VALORES NAS POSIÇOES CERTAS PARA O ENVIO
    int j,t;
    char	virg=',';
QString temp1;
                    t=1;
	      contador=3;   
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp1 =temp1 + ch; 
		     contador++;
		 }
		 
	     }	    
	     FancaE_textEdit-> setText(temp1);
	     t=1;
	     contador=contador + 1;
QString temp2;

	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp2 =temp2 + ch; 
		     contador++;
		 }
	     }
	     LancaE_textEdit-> setText(temp2); 
	     
	     t=1;
	     contador=contador + 1;
QString temp3;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp3 =temp3 + ch; 
		     contador++;
		 }
	     }
	     VancaE_textEdit-> setText(temp3);
	     
	     t=1;
	     contador=contador + 1;
QString temp4;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp4 =temp4 + ch; 
		     contador++;
		 }
	     }
	      joelhoE_textEdit-> setText(temp4);    
	      
	     t=1;
	     contador=contador + 1;
QString temp5;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp5 =temp5 + ch; 
		     contador++;
		 }
	     }
	      IpeE_textEdit-> setText(temp5);  	   
	      
	     t=1;
	     contador=contador + 1;
QString temp6;
	     while(t>0){
		 ch = line.at( contador );
		 if (ch==virg)
		 {
		     t=0;
		 }
		 else
		 {
		     temp6 =temp6 + ch; 
		     contador++;
		 }	    
	       tornozeloE_textEdit-> setText(temp6); 	      
	}
	     
}
void CtrlForm::gravar_pos()
{
struct timeval t0, t1;
struct timezone tzp;
 //clean_buffer();
//ENVIA BYTES PARA A RECEBER OS VALORES DAS JUNTAS E SENSORES DE CADA PERNA
unsigned char res_pe_D[42], res_pe_E[42];
unsigned char buf,temp_D[6],temp_E[6];
int res , cont = 0 , i=0 , j, cont1=0 ,cont2=0, error=0,r,k; 
QString temp,temp1;

if(teste2==0)   
    {
    for (k=1;k<2000;k++){
  /*  //PE DIREITO- ADQUIRIR VALORES DOS SENSORES
    for (cont=0;cont<7;cont++){
	porta.Write(val_juntas_E[cont],3);
	do{
	    res = porta.Read(&buf, 1);    
	    if (res<=0)
	    {
		printf("nada para ler\n");
		error++;   
		}
	    
	    if (res>0)
	    {
		if (buf==255) 
		{
		    i=0;
		    printf("+");
		}
		temp_D[i++] = buf;
		
	    }
	
	}while (i < 6);
	if (error>5) {
		    printf("falha de comunicaçao\n");
		    error=0;
		    break;
		    //exit(0);		    
		}
	
	for (r=0;r<6;r++){
	    res_pe_D[cont1]=temp_D[r];
	    cont1++;
	}
    }
    
 textBrowser7->clear();
    for (i=0;i<42;i++){
	if (i==0){
	    temp.sprintf("\n");
	    temp = textBrowser7->text() + temp;
	    textBrowser7->setText(temp);
	    temp.sprintf(" %d,",res_pe_D[i]);
	    temp = textBrowser7->text() + temp;
	    textBrowser7->scrollToBottom();
	    textBrowser7->setText(temp);
	    
	}
	if (i>0){
	//printf("%d\n",i);
	temp.sprintf(" %d,",res_pe_D[i]);
	temp = textBrowser7->text() + temp;
	textBrowser7->setText(temp);
	textBrowser7->scrollToBottom();
	}
}
if ((cont1 == 42) & (res_pe_D[1]==(unsigned char)S_ANCA_FRENTE_D)& (res_pe_D[31]==(unsigned char)S_PE_FRENTE_D) & (res_pe_D[37]==(unsigned char)SENSOR_PE_D))  {
                                           printf("pe D/cont1=%d\n",cont1);			
                                           temp1.sprintf("\n");
			temp1 = gravar_textBrowser->text() + temp1;
			gravar_textBrowser->setText(temp1);
			gravar_textBrowser->scrollToBottom();
			gravar_textBrowser->setText("PD,");
			cont2=5;
			while (cont2<36) {
				temp1.sprintf(" %d,",res_pe_D[cont2]);
				temp1 = gravar_textBrowser->text() + temp1;
				gravar_textBrowser->setText(temp1);
				gravar_textBrowser->scrollToBottom();
				cont2= cont2+6;
			}
			for (j=38;j<42;j++){
			    if (j<41){
				temp1.sprintf(" %d,", res_pe_D[j]);
			    }else{
				temp1.sprintf(" %d,", res_pe_D[j]);
			    }
			   temp1 = gravar_textBrowser->text() + temp1;
			   gravar_textBrowser->setText(temp1);
			   gravar_textBrowser->scrollToBottom();
			}
		}
*/
//PE ESQUERDO - ADQUIRIR VALORES DOS SENSORES
cont=0;
cont1=0;
cont2=0;
for (cont=0;cont<7;cont++){
               gettimeofday( &t0, &tzp);
	porta.Write(val_juntas_E[cont],3);
	do{
	    res = porta.Read(&buf, 1);    
	    if (res<=0)
	    {
		printf("nada para ler\n");
	    }
	    if (res>0)
	    {
		if (buf==255) 
		{
		    i=0;
		    printf("+");
		    error++;
  
		}
		else if(error < 5) error = 0;
		
		temp_E[i++] = buf;
	    }
	if (error>5) {
		   printf("OverRun no PIC\n");
		    //exit(0);
		    break; /*exit do-while*/
		}
	gettimeofday( &t1, &tzp);
	if( ((t1.tv_sec-t0.tv_sec)*1000L + (t1.tv_usec-t0.tv_usec)/1000L) > 500L )
		{
			printf("\nAnswer did not arrive in 500 ms\n");
			error =6;
			break;
		}
	}while (i < 6);	
	

	if (error>5)   break; /* Exit for loop*/
		
	for (r=0;r<6;r++){
	    res_pe_E[cont1]=temp_E[r];
	    cont1++;
	}
    }


//    textBrowser7_2->clear();
//    for (i=0;i<42;i++){
//	if (i==0){
//	    temp.sprintf("\n");
//	    temp = textBrowser7_2->text() + temp;
//	    textBrowser7_2->setText(temp);
//	    temp.sprintf(" %d,",res_pe_E[i]);
//	    temp = textBrowser7_2->text() + temp;
//	    textBrowser7_2->scrollToBottom();
//	    textBrowser7_2->setText(temp);
//	    
//	}
//	if (i>0){
//	//printf("%d\n",i);
//	temp.sprintf(" %d,",res_pe_E[i]);
//	temp = textBrowser7_2->text() + temp;
//	textBrowser7_2->setText(temp);
//	textBrowser7_2->scrollToBottom();
//	}
//}

//if  ((cont1 == 42) & (res_pe_E[1]==(unsigned char)S_ANCA_FRENTE_E) & (res_pe_E[31]==(unsigned char)S_PE_FRENTE_E)& (res_pe_E[37]==(unsigned char)SENSOR_PE_E)) {
//                                           printf("pe Esq /cont1=%d\n",cont1);			
//                                           temp.sprintf("\n");
//			temp = gravar_textBrowser_2->text() + temp;
//			gravar_textBrowser_2->setText(temp);
//			gravar_textBrowser_2->scrollToBottom();
//			gravar_textBrowser_2->setText("PE,");
//			cont2=5;
//			while (cont2<36) {
//				temp.sprintf(" %d,",res_pe_E[cont2]);
//				temp = gravar_textBrowser_2->text() + temp;
//				gravar_textBrowser_2->setText(temp);
//				gravar_textBrowser_2->scrollToBottom();
//				cont2= cont2+6;
//			}
//			for (j=38;j<42;j++){
//			    if (j<41){
//				temp.sprintf(" %d,", res_pe_E[j]);
//			    }else
//			    {
//				temp.sprintf(" %d", res_pe_E[j]);
//			    }
//			   temp = gravar_textBrowser_2->text() + temp;
//			   gravar_textBrowser_2->setText(temp);
//			   gravar_textBrowser_2->scrollToBottom();
//			}
//		}
//
////ESCREVER NAS CAIXAS DE TEXTO
//gravar_total_textBrowser->setText(gravar_textBrowser->text());
//temp = gravar_total_textBrowser->text();
//temp.sprintf("\n");
//temp = gravar_total_textBrowser->text() + temp;
//
//temp = temp + gravar_textBrowser_2->text();
//gravar_total_textBrowser->setText(temp);
//textBrowser2->scrollToBottom();
//
// //ESCREVER NO FICHEIRO
//      QFile file( mov_juntas_grav_textEdit->text() );
//      file.open( IO_WriteOnly | IO_Append );
//      file.writeBlock( gravar_total_textBrowser->text(), qstrlen( gravar_total_textBrowser->text() ) );
//      temp.sprintf("\n");
//      file.writeBlock( temp, qstrlen( temp) );
//      file.close();
     //active_timer3();


//
//	FILE *fp;
//	char stuff[25];
//	int index;
//	fp = fopen("sensor.txt","w"); 
//					/* open for writing					*/ 
//	strcpy(stuff,"This is an example line.");
//	for (index = 1; index <= 10; index++)  
//		fprintf(fp,"%s Line number %d\n", stuff, index); 
//	fclose(fp);				/* close the file before ending program		*/
}  
  }
}


void CtrlForm::parar_gravar()
{
   teste2=1;
}
void CtrlForm::nada()
{
    teste = 0;
  gravar_pos();
}
void CtrlForm::Mov_juntas_sem_gravar()
{
   clean_buffer();
  unsigned char send_juntas[12];
  unsigned char vel_juntas;
  //PERNA DIREITA
  QString aux1 = FancaD_textEdit->text();
  send_juntas[0] = aux1.toInt();
  QString aux2 = LancaD_textEdit->text();
  send_juntas[1] = aux2.toInt();
  QString aux3 = VancaD_textEdit->text();
  send_juntas[2] = aux3.toInt();
  QString aux4 = joelhoD_textEdit->text();
  send_juntas[3] = aux4.toInt();
  QString aux5 = IpeD_textEdit->text();
  send_juntas[4] = aux5.toInt();
  QString aux6 = tornozeloD_textEdit->text();
  send_juntas[5] = aux6.toInt();
  
  //PERNA ESQUERDA
  QString aux1_1 = FancaE_textEdit->text();
  send_juntas[6] = aux1_1.toInt();
  QString aux2_2 = LancaE_textEdit->text();
  send_juntas[7] = aux2_2.toInt();
  QString aux3_3 = VancaE_textEdit->text();
  send_juntas[8] = aux3_3.toInt();
  QString aux4_4 = joelhoE_textEdit->text();
  send_juntas[9] = aux4_4.toInt();
  QString aux5_5 = IpeE_textEdit->text();
  send_juntas[10] = aux5_5.toInt();
  QString aux6_6 = tornozeloE_textEdit->text();
  send_juntas[11] = aux6_6.toInt();
  
  QString aux_vel = vel_comboBox->currentText();
  vel_juntas = aux_vel.toInt();
  
//  unsigned char val[36] = {74,send_juntas[0],0,73,send_juntas[1],0,72,send_juntas[2],0,66,send_juntas[3],0,64,send_juntas[4],0,65,send_juntas[5],0,78,send_juntas[6],0,77,send_juntas[7],0,76,send_juntas[8],0,70,send_juntas[9],0,68,send_juntas[10],0,69,send_juntas[11],0};
  unsigned char val_D[18] = {74,send_juntas[0],vel_juntas,73,send_juntas[1],vel_juntas,72,send_juntas[2],vel_juntas,66,send_juntas[3],vel_juntas,64,send_juntas[4],vel_juntas,65,send_juntas[5],vel_juntas};
  unsigned char val_E[18]  = {78,send_juntas[6],vel_juntas,77,send_juntas[7],vel_juntas,76,send_juntas[8],vel_juntas,70,send_juntas[9],vel_juntas,68,send_juntas[10],vel_juntas,69,send_juntas[11],vel_juntas};  
  
unsigned char receb[255];
int res;

porta.Write(val_D, 18);  
//res = porta.Read(receb,18);
porta.Write(val_E, 18);
//res = porta.Read(receb,36);

//printf("res= %d\n",res);    

}

