/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**#include <qmessagebox.h>
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
   
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <qvalidator.h>
#include "serial.h"
#include <qmessagebox.h>
#include <qtextbrowser.h>
#include <qtimer.h> 
#include <qdatetime.h>
#include <qfile.h>
#include <qdatetime.h> 
#include <qslider.h> 
#include <qscrollbar.h> 
#include <qcombobox.h>
#include <qlineedit.h> 

int teste = 0;
Serial porta;


void CtrlForm::init()
    {
      PortaConfig();
    }

void CtrlForm::send()
{

    
    unsigned char aux[3]; 
    //--VAI BUSCAR OS VALORES DA JUNTA, POS E SPEED 
    QString junta =  jointlineEdit->text();
    int pos = positionscrollBar->value();
    QString speed =SPEDD_comboBox ->currentText();
 
    //--CAT TODAS AS STRING ------------
    aux[0] = junta.toInt();
    aux[1] = pos;
    aux[2] = speed.toInt();
    
    //--ENVIA PELA PORTA----------
    porta.Write(aux, 3);
    read();
}


void CtrlForm::read()
{  
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   if (porta.IsOpen()) {
       QMessageBox::information( this,"Debug", "Porta aberta");
   }
    
   res = porta.Read(buff, 100);
   char buf[100];
//   sprintf(buf, "%i", res);
   //QMessageBox::information( this,"Porta_leu", buf);
   
   
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			//QMessageBox::information( this,"Estado", "Estamos a receber");
			
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm:: PortaConfig()
{
     QString port = port_comboBox->currentText();
     porta.SetName(port);
      
     int baud_aux,baud;
     QString baudrate =baudrate_comboBox ->currentText();
     baud_aux = baudrate.toInt();
     switch(baud_aux)
              {
	     case   19200:
		 baud = 13;
		 break;
	     case   9600:
	               baud = 12;
		 break;
	}
		     
     porta.SetBaudRate(baud);

     porta.SetParity(0);

     porta.SetDataBits(DATA_8);

     porta.SetStopBits(1);

     porta.SetFlowControl(0);
     
     porta.SetTimeout(1);  
     //--VERIFICA SE APORTA ESTA ABERTA

      if (porta.Open() == FALSE)  
          {
	char str[100];
	porta.GetErrorMsg(str);
	QMessageBox::information( this, "Erro", str);
      };
}



void CtrlForm::position_timerDone()
{
    //limpa o buffer da porta
    clean_buffer();
    //----MANDAR ORDEM PARA ENVIO DE VALORES DAS POSIÇOES JUNTAS
    unsigned char send[3];
    send[1] =0;
    send[2] =0;
    
    int val[8] = {128,129,130,132,132,133,134,137};
    
    Rec_textBrowser->clear();
    //--ENVIA PELA PORTA----------
    int res, j,i;
    for (j=0;j<8;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	unsigned char buff[255];
	res = porta.Read(buff, 3);
                             
		if (res > 0) {
			aux.sprintf("\n");
			aux = Rec_textBrowser->text() + aux;
			Rec_textBrowser->setText(aux);
			Rec_textBrowser->scrollToBottom();
			for (i=0; i<res; i++) {
				
			              if (i<res-1)
			              {
				aux.sprintf(" %d,", buff[i]);
			              }
				else
				{
				 aux.sprintf(" %d", buff[i]);  
				}
				aux = Rec_textBrowser->text() + aux;
				Rec_textBrowser->setText(aux);
				Rec_textBrowser->scrollToBottom();
				
			}
		}
		//Actualiza a monitorizaçao das posiçoes das juntas
		int anca, joelho, inc_pes, tornozelo;
		switch (j)
		{
		case 0:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider->setValue(inc_pes);
	               break;
		 case 1:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider->setValue(tornozelo);
	               break;
		 case 2:
		        joelho = buff[2]; 
	                      JOELHO_slider->setValue(joelho);
	               break;
		 case 3:
		        anca = buff[2]; 
	                      ANCA_slider->setValue(anca);
	               break;
		 case 4:
		        inc_pes = buff[2]; 
	                      PE_INCLI_slider_2->setValue(anca);
	               break;
		 case 5:
		        tornozelo = buff[2]; 
	                      TORNOZELO_slider_2->setValue(tornozelo);
	               break;
		 case 6:
		        joelho = buff[2]; 
	                      JOELHO_slider_2->setValue(joelho);
	               break;
		 case 7:
		        anca = buff[2]; 
	                      ANCA_slider_2->setValue(anca);
	               break;
	               }
	                 
	    }
      //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      QFile file( textEdit2->text ()  );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( Rec_textBrowser->text(), qstrlen( Rec_textBrowser->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer1();		
     }
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}

void CtrlForm::sensor_timerDone()
{
 //----MANDAR ORDEM PARA ENVIO DE VALORES DOS SENSORES
    
    //limpa o buffer da porta
    clean_buffer();
    //ESCOLHA DA PLACA A MONITORIZAR
    int val[4];//= {192,196,200,204,208,212,216,220};
 
    QString val_aux1 = endPES1_comboBox->currentText();
    QString val_aux2 = endPES2_comboBox->currentText();
    QString val_aux3 = endINC_comboBox->currentText();
    QString val_aux4 = endGIROS_comboBox->currentText();

    val[0] = val_aux1.toInt();
    val[1] = val_aux2.toInt();
    val[2] = val_aux3.toInt();
    val[3] = val_aux4.toInt();
    
    textBrowser3->clear();
  
    unsigned char send[3];
    send[1]=0;
    send[2]=0;
    //--ENVIA PELA PORTA----------

    unsigned char buff[255];
    int res, j,i;
    
    for (j=0;j<4;j++)
    {
	send[0]= val[j];
	porta.Write(send, 3);  
	//--RECEBE PELA PORTA---------
	QString aux;
	
	res = porta.Read(buff, 4);
                             
		if ((res > 0) & (res==4)) {
			aux.sprintf("\n");
			aux = textBrowser3->text() + aux;
			textBrowser3->setText(aux);
			textBrowser3->scrollToBottom();
			for (i=0; i<res; i++) {
			              if (i<res-1)
			              {
				aux.sprintf(" %d,", buff[i]);
			              }
				else
				{
				 aux.sprintf(" %d", buff[i]);  
				}      
				aux = textBrowser3->text() + aux;
				textBrowser3->setText(aux);
				textBrowser3->scrollToBottom();
				
			}
		}
	      //--VISUALIZAÇAO SENSOR PES , INCLINOMETROS, GIROSCOPIO
		
		//PE DIREITO
		if (j==0)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider->setValue(pe1);
		    pe2_slider->setValue(pe2);	
		    pe3_slider->setValue(pe3);	
		    pe4_slider->setValue(pe4);	
		}
		//PE ESQUERDO
		if (j==1)
		{
		    int pe1,pe2,pe3,pe4;
		    pe1 = buff[0]; 
		    pe2 = buff[1]; 
		    pe3 = buff[2]; 
		    pe4 = buff[3]; 
		    
		    pe1_slider_2->setValue(pe1);
		    pe2_slider_2->setValue(pe2);	
		    pe3_slider_2->setValue(pe3);	
		    pe4_slider_2->setValue(pe4);	
		}
		//INCLINOMETRO
		if(j==2)
		{
		    int inclin1,inclin2;
		    inclin1 = buff[0];
		    inclin1_slider->setValue(inclin1);
		    inclin2 = buff[1];
		    inclin2_slider->setValue(inclin2);
		 }
                               //GIROSCOPIO
    		if (j==3)
                                {
		    int giro;
		    giro = buff[0];
		    giro_slider->setValue(giro);
		 }
    
	    }
   
    
       //DATA E HORA
      QDateTime dt = QDateTime::currentDateTime();
      QString data=dt.toString();
      //--ESCREVER NUM FICHEIRO
      //QString name =c->currentText();
      QFile file( textEdit3->text () );
      file.remove();
      file.open( IO_WriteOnly | IO_Append );
      file.writeBlock( data, qstrlen( data) );
      file.writeBlock( textBrowser3->text(), qstrlen( textBrowser3->text() ) );
      file.close();
      //------------------------------------------------
     if (teste==0)
     {
        active_timer2();		
     } 
     else
     {
      teste = 0;
      QMessageBox::information( this,"INFO", "END COMUNICATION");
     }
}	

void CtrlForm::active_timer1()
{
        //--ACTIVAR UM TIMER1---------------------------------------  
        teste = 0;
        QTimer *timer1 = new QTimer( this);
        connect( timer1, SIGNAL(timeout()),SLOT(position_timerDone()) );
        timer1->start( 100, TRUE ); 
}

void CtrlForm::active_timer2()
{
        //--ACTIVAR UM TIMER2---------------------------------------  
        teste = 0;
        QTimer *timer2 = new QTimer( this);
        connect( timer2, SIGNAL(timeout()),SLOT(sensor_timerDone()) );
        timer2->start( 100, TRUE ); 
}

void CtrlForm::quit_timer()
{
  teste = 1;
}


void CtrlForm::clean_buffer()
{
    int res;
   unsigned char buff[255];
   res = porta.Read(buff, 10);
}

void CtrlForm::can_teste()
{
    unsigned char send[3]={0,255,255};
    
   porta.Write(send, 3);
   
   QString aux3;
   unsigned char buff[255];
   int res, i;
    
   res = porta.Read(buff, 8);
 
		if (res > 0) {
			aux3.sprintf("\n");
			aux3 = textBrowser2->text() + aux3;
			textBrowser2->setText(aux3);
			textBrowser2->scrollToBottom();
			
			for (i=0; i<res; i++) {
			              aux3.sprintf("[%d]", buff[i]);
				aux3 = textBrowser2->text() + aux3;
				textBrowser2->setText(aux3);
				textBrowser2->scrollToBottom();
			}
		    }	
}

void CtrlForm::clean_juntas()
{
ANCA_slider->setValue(0);
JOELHO_slider->setValue(0);
TORNOZELO_slider->setValue(0);
PE_INCLI_slider->setValue(0);
ANCA_slider_2->setValue(0);
JOELHO_slider_2->setValue(0);
TORNOZELO_slider_2->setValue(0);
PE_INCLI_slider_2->setValue(0);
Rec_textBrowser->clear();
}


void CtrlForm::clean_sensores()
{
pe1_slider->setValue(0);
pe2_slider->setValue(0);
pe3_slider->setValue(0);
pe4_slider->setValue(0);
pe1_slider_2->setValue(0);
pe2_slider_2->setValue(0);
pe3_slider_2->setValue(0);
pe4_slider_2->setValue(0);
inclin1_slider->setValue(0);
inclin2_slider->setValue(0);
giro_slider->setValue(0);
textBrowser3->clear();
}
